Bug 1182193 - assertion failure with very high MTU
Summary: assertion failure with very high MTU
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: openvswitch
Version: 20
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Flavio Leitner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-01-14 15:23 UTC by Flavio Leitner
Modified: 2015-01-27 02:59 UTC (History)
3 users (show)

Fixed In Version: openvswitch-2.3.1-2.git20150113.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of: 1182107
Environment:
Last Closed: 2015-01-27 02:59:34 UTC
Type: Bug


Attachments (Terms of Use)

Description Flavio Leitner 2015-01-14 15:23:19 UTC
+++ This bug was initially created as a clone of Bug #1182107 +++

Update OVS package to include the following two fixes:

commit 3282e5118707efc3ba07f7bd17f5f82fe931a732                                
Author: Ben Pfaff <blp@nicira.com>
Date:   Sun Jan 11 13:45:36 2015 -0800

    dpif-linux: Drop oversized packets instead of assert-failing.
    
    A packet sent to a Netlink datapath has to fit within a Netlink attribute.
    Until now, this was only checked in an assertion inside the Netlink code,
    which meant that trying to send a too-large packet (approximate 64 kB or
    larger) would assert-fail.  It's better to just drop those packets, which
    this commit does.
    
    Reported-by: Shuping Cui <scui@redhat.com>
    Reported-by: Jiri Benc <jbenc@redhat.com>
    Signed-off-by: Ben Pfaff <blp@nicira.com>
    Acked-by: Jesse Gross <jesse@nicira.com>

commit f3c7ec6a2a19bffdfa5218f984bda53582ecb8dc
Author: Ben Pfaff <blp@nicira.com>
Date:   Wed Jan 7 13:19:41 2015 -0800

    netlink: Refine calculation of maximum-length attributes.
    
    Until now the Netlink code has considered an attribute to exceed the
    maximum length if the *padded* size of the attribute exceeds 65535 bytes.
    For example, an attribute with a 65529-byte payload, together with 4-byte
    header and 3 bytes of padding, takes up 65536 bytes and therefore the
    existing code rejected it.
    
    However, the restriction on Netlink attribute sizes is to ensure that the
    length fits in the 16-bit nla_len field.  This field includes the 4-byte
    header but not the padding, so a 65529-byte payload is acceptable because,
    with the header but not the padding, it comes to only 65533 bytes.
    
    Thus, this commit relaxes the restriction on Netlink attribute sizes by
    omitting padding from size checks.  It also changes one piece of code that
    inlined a size check to use the central function nl_attr_oversized().
    
    This change should fix an assertion failure when OVS userspace passes a
    maximum-size (65529+ byte) packet back to the kernel.
    
    Reported-by: Shuping Cui <scui@redhat.com>
    Reported-by: Jiri Benc <jbenc@redhat.com>
    Signed-off-by: Ben Pfaff <blp@nicira.com>
    Acked-by: Jesse Gross <jesse@nicira.com>

Comment 1 Fedora Update System 2015-01-14 18:18:05 UTC
openvswitch-2.3.1-2.git20150113.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/openvswitch-2.3.1-2.git20150113.fc20

Comment 2 Fedora Update System 2015-01-17 05:50:21 UTC
Package openvswitch-2.3.1-2.git20150113.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openvswitch-2.3.1-2.git20150113.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-0841/openvswitch-2.3.1-2.git20150113.fc20
then log in and leave karma (feedback).

Comment 3 Fedora Update System 2015-01-27 02:59:34 UTC
openvswitch-2.3.1-2.git20150113.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.